#include <MacroPatternMatch.h>
#include "HROOTHistTGraph.h"
#include "TGraphAsymmErrors.h"
#include "HROOTHistTGraphAsymmErrors.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TGRAPH_DEF_VIRT(TGraphAsymmErrors)
TNAMED_DEF_VIRT(TGraphAsymmErrors)
TATTLINE_DEF_VIRT(TGraphAsymmErrors)
TATTFILL_DEF_VIRT(TGraphAsymmErrors)
TATTMARKER_DEF_VIRT(TGraphAsymmErrors)
TOBJECT_DEF_VIRT(TGraphAsymmErrors)
DELETABLE_DEF_VIRT(TGraphAsymmErrors)

TGRAPHASYMMERRORS_DEF_VIRT(TGraphAsymmErrors)

TGRAPHASYMMERRORS_DEF_NONVIRT(TGraphAsymmErrors)

