#include <MacroPatternMatch.h>
#include "HROOTCoreTDirectory.h"
#include "HROOTHistTF1.h"
#include "HROOTCoreTArrayD.h"
#include "HROOTHistTAxis.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "TH1.h"
#include "HROOTHistTH1.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TH1)
TATTLINE_DEF_VIRT(TH1)
TATTFILL_DEF_VIRT(TH1)
TATTMARKER_DEF_VIRT(TH1)
TOBJECT_DEF_VIRT(TH1)
DELETABLE_DEF_VIRT(TH1)

TH1_DEF_VIRT(TH1)

TH1_DEF_NONVIRT(TH1)

