#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH1D__
#define __HROOT_HIST__TH1D__

#include "HROOT-histType.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTArrayD.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH1D_DECL_VIRT 
#define TH1D_DECL_VIRT(Type) \


#undef TH1D_DECL_NONVIRT 
#define TH1D_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTH1D ( const char* name, const char* title, int nbinsx, double xlow, double xup )

#undef TH1D_DEF_VIRT
#define TH1D_DEF_VIRT(Type)\


#undef TH1D_DEF_NONVIRT
#define TH1D_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTH1D ( const char* name, const char* title, int nbinsx, double xlow, double xup )\
{\
Type * newp = new Type (name, title, nbinsx, xlow, xup); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TH1_DECL_VIRT(TH1D);
TARRAYD_DECL_VIRT(TH1D);
TNAMED_DECL_VIRT(TH1D);
TATTLINE_DECL_VIRT(TH1D);
TATTFILL_DECL_VIRT(TH1D);
TATTMARKER_DECL_VIRT(TH1D);
TOBJECT_DECL_VIRT(TH1D);
DELETABLE_DECL_VIRT(TH1D);
TARRAY_DECL_VIRT(TH1D);


TH1D_DECL_VIRT(TH1D);


TH1D_DECL_NONVIRT(TH1D);


#endif // __HROOT_HIST__TH1D__

#ifdef __cplusplus
}
#endif

