#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH2F__
#define __HROOT_HIST__TH2F__

#include "HROOT-histType.h"
#include "HROOTHistTH2.h"
#include "HROOTCoreTArrayF.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH2F_DECL_VIRT 
#define TH2F_DECL_VIRT(Type) \


#undef TH2F_DECL_NONVIRT 
#define TH2F_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTH2F ( const char* name, const char* title, int nbinsx, double xlow, double xup, int nbinsy, double ylow, double yup )

#undef TH2F_DEF_VIRT
#define TH2F_DEF_VIRT(Type)\


#undef TH2F_DEF_NONVIRT
#define TH2F_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTH2F ( const char* name, const char* title, int nbinsx, double xlow, double xup, int nbinsy, double ylow, double yup )\
{\
Type * newp = new Type (name, title, nbinsx, xlow, xup, nbinsy, ylow, yup); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TH2_DECL_VIRT(TH2F);
TARRAYF_DECL_VIRT(TH2F);
TH1_DECL_VIRT(TH2F);
TNAMED_DECL_VIRT(TH2F);
TATTLINE_DECL_VIRT(TH2F);
TATTFILL_DECL_VIRT(TH2F);
TATTMARKER_DECL_VIRT(TH2F);
TOBJECT_DECL_VIRT(TH2F);
DELETABLE_DECL_VIRT(TH2F);
TARRAY_DECL_VIRT(TH2F);


TH2F_DECL_VIRT(TH2F);


TH2F_DECL_NONVIRT(TH2F);


#endif // __HROOT_HIST__TH2F__

#ifdef __cplusplus
}
#endif

