#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH3D__
#define __HROOT_HIST__TH3D__

#include "HROOT-histType.h"
#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayD.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH3D_DECL_VIRT 
#define TH3D_DECL_VIRT(Type) \


#undef TH3D_DECL_NONVIRT 
#define TH3D_DECL_NONVIRT(Type) \


#undef TH3D_DEF_VIRT
#define TH3D_DEF_VIRT(Type)\


#undef TH3D_DEF_NONVIRT
#define TH3D_DEF_NONVIRT(Type)\


TH3_DECL_VIRT(TH3D);
TARRAYD_DECL_VIRT(TH3D);
TH1_DECL_VIRT(TH3D);
TATT3D_DECL_VIRT(TH3D);
TNAMED_DECL_VIRT(TH3D);
TATTLINE_DECL_VIRT(TH3D);
TATTFILL_DECL_VIRT(TH3D);
TATTMARKER_DECL_VIRT(TH3D);
TOBJECT_DECL_VIRT(TH3D);
DELETABLE_DECL_VIRT(TH3D);
TARRAY_DECL_VIRT(TH3D);


TH3D_DECL_VIRT(TH3D);


TH3D_DECL_NONVIRT(TH3D);


#endif // __HROOT_HIST__TH3D__

#ifdef __cplusplus
}
#endif

