#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH3I__
#define __HROOT_HIST__TH3I__

#include "HROOT-histType.h"
#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayI.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH3I_DECL_VIRT 
#define TH3I_DECL_VIRT(Type) \


#undef TH3I_DECL_NONVIRT 
#define TH3I_DECL_NONVIRT(Type) \


#undef TH3I_DEF_VIRT
#define TH3I_DEF_VIRT(Type)\


#undef TH3I_DEF_NONVIRT
#define TH3I_DEF_NONVIRT(Type)\


TH3_DECL_VIRT(TH3I);
TARRAYI_DECL_VIRT(TH3I);
TH1_DECL_VIRT(TH3I);
TATT3D_DECL_VIRT(TH3I);
TNAMED_DECL_VIRT(TH3I);
TATTLINE_DECL_VIRT(TH3I);
TATTFILL_DECL_VIRT(TH3I);
TATTMARKER_DECL_VIRT(TH3I);
TOBJECT_DECL_VIRT(TH3I);
DELETABLE_DECL_VIRT(TH3I);
TARRAY_DECL_VIRT(TH3I);


TH3I_DECL_VIRT(TH3I);


TH3I_DECL_NONVIRT(TH3I);


#endif // __HROOT_HIST__TH3I__

#ifdef __cplusplus
}
#endif

