#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__THStack__
#define __HROOT_HIST__THStack__

#include "HROOT-histType.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-coreType.h"

#undef THSTACK_DECL_VIRT 
#define THSTACK_DECL_VIRT(Type) \


#undef THSTACK_DECL_NONVIRT 
#define THSTACK_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTHStack ( const char* name, const char* title )

#undef THSTACK_DEF_VIRT
#define THSTACK_DEF_VIRT(Type)\


#undef THSTACK_DEF_NONVIRT
#define THSTACK_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTHStack ( const char* name, const char* title )\
{\
Type * newp = new Type (name, title); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TNAMED_DECL_VIRT(THStack);
TOBJECT_DECL_VIRT(THStack);
DELETABLE_DECL_VIRT(THStack);


THSTACK_DECL_VIRT(THStack);


THSTACK_DECL_NONVIRT(THStack);


#endif // __HROOT_HIST__THStack__

#ifdef __cplusplus
}
#endif

