{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TFitResult.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TFitResult.RawType
import HROOT.Core.TNamed.Interface

class ITNamed a => ITFitResult a

upcastTFitResult ::
                 forall a . (FPtr a, ITFitResult a) => a -> TFitResult
upcastTFitResult h
  = let fh = get_fptr h
        fh2 :: Ptr RawTFitResult = castPtr fh
      in cast_fptr_to_obj fh2

downcastTFitResult ::
                   forall a . (FPtr a, ITFitResult a) => TFitResult -> a
downcastTFitResult h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
