{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TFitResultPtr.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TFitResultPtr.RawType
import HROOT.Hist.TFitResult.RawType

class ITFitResultPtr a

upcastTFitResultPtr ::
                    forall a . (FPtr a, ITFitResultPtr a) => a -> TFitResultPtr
upcastTFitResultPtr h
  = let fh = get_fptr h
        fh2 :: Ptr RawTFitResultPtr = castPtr fh
      in cast_fptr_to_obj fh2

downcastTFitResultPtr ::
                      forall a . (FPtr a, ITFitResultPtr a) => TFitResultPtr -> a
downcastTFitResultPtr h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
