{-# LANGUAGE FlexibleInstances, FlexibleContexts, TypeFamilies,
  MultiParamTypeClasses, OverlappingInstances, IncoherentInstances
  #-}
module HROOT.Hist.TGraphAsymmErrors.Cast where
import Foreign.Ptr
import FFICXX.Runtime.Cast
import System.IO.Unsafe
import HROOT.Hist.TGraphAsymmErrors.RawType
import HROOT.Hist.TGraphAsymmErrors.Interface

instance (ITGraphAsymmErrors a, FPtr a) => Castable a
         (Ptr RawTGraphAsymmErrors) where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))

instance Castable TGraphAsymmErrors (Ptr RawTGraphAsymmErrors)
         where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))
