{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TGraphAsymmErrors.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TGraphAsymmErrors.RawType
import HROOT.Hist.TGraph.Interface

class ITGraph a => ITGraphAsymmErrors a

upcastTGraphAsymmErrors ::
                        forall a . (FPtr a, ITGraphAsymmErrors a) => a -> TGraphAsymmErrors
upcastTGraphAsymmErrors h
  = let fh = get_fptr h
        fh2 :: Ptr RawTGraphAsymmErrors = castPtr fh
      in cast_fptr_to_obj fh2

downcastTGraphAsymmErrors ::
                          forall a . (FPtr a, ITGraphAsymmErrors a) => TGraphAsymmErrors -> a
downcastTGraphAsymmErrors h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
