{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TGraphBentErrors.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TGraphBentErrors.RawType
import HROOT.Hist.TGraph.Interface

class ITGraph a => ITGraphBentErrors a

upcastTGraphBentErrors ::
                       forall a . (FPtr a, ITGraphBentErrors a) => a -> TGraphBentErrors
upcastTGraphBentErrors h
  = let fh = get_fptr h
        fh2 :: Ptr RawTGraphBentErrors = castPtr fh
      in cast_fptr_to_obj fh2

downcastTGraphBentErrors ::
                         forall a . (FPtr a, ITGraphBentErrors a) => TGraphBentErrors -> a
downcastTGraphBentErrors h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
