{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1C.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TH1C.RawType
import HROOT.Hist.TH1C.FFI
import HROOT.Hist.TH1C.Interface
import HROOT.Hist.TH1C.Cast
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArrayD.Cast
import HROOT.Core.TArrayD.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH1.RawType
import HROOT.Hist.TH1.Cast
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayC.RawType
import HROOT.Core.TArrayC.Cast
import HROOT.Core.TArrayC.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface

instance ITH1C TH1C

instance ITH1 TH1C where
        add = xform2 c_th1c_add
        addBinContent = xform2 c_th1c_addbincontent
        chi2Test = xform3 c_th1c_chi2test
        computeIntegral = xform0 c_th1c_computeintegral
        directoryAutoAdd = xform1 c_th1c_directoryautoadd
        divide = xform5 c_th1c_divide
        drawCopyTH1 = xform1 c_th1c_drawcopyth1
        drawNormalized = xform2 c_th1c_drawnormalized
        drawPanelTH1 = xform0 c_th1c_drawpanelth1
        bufferEmpty = xform1 c_th1c_bufferempty
        evalF = xform2 c_th1c_evalf
        fFT = xform2 c_th1c_fft
        fill1 = xform1 c_th1c_fill1
        fill1w = xform2 c_th1c_fill1w
        fillN1 = xform4 c_th1c_filln1
        fillRandom = xform2 c_th1c_fillrandom
        findBin = xform3 c_th1c_findbin
        findFixBin = xform3 c_th1c_findfixbin
        findFirstBinAbove = xform2 c_th1c_findfirstbinabove
        findLastBinAbove = xform2 c_th1c_findlastbinabove
        fit = xform5 c_th1c_fit
        fitPanelTH1 = xform0 c_th1c_fitpanelth1
        getNdivisionA = xform1 c_th1c_getndivisiona
        getAxisColorA = xform1 c_th1c_getaxiscolora
        getLabelColorA = xform1 c_th1c_getlabelcolora
        getLabelFontA = xform1 c_th1c_getlabelfonta
        getLabelOffsetA = xform1 c_th1c_getlabeloffseta
        getLabelSizeA = xform1 c_th1c_getlabelsizea
        getTitleFontA = xform1 c_th1c_gettitlefonta
        getTitleOffsetA = xform1 c_th1c_gettitleoffseta
        getTitleSizeA = xform1 c_th1c_gettitlesizea
        getTickLengthA = xform1 c_th1c_getticklengtha
        getBarOffset = xform0 c_th1c_getbaroffset
        getBarWidth = xform0 c_th1c_getbarwidth
        getContour = xform1 c_th1c_getcontour
        getContourLevel = xform1 c_th1c_getcontourlevel
        getContourLevelPad = xform1 c_th1c_getcontourlevelpad
        getBin = xform3 c_th1c_getbin
        getBinCenter = xform1 c_th1c_getbincenter
        getBinContent1 = xform1 c_th1c_getbincontent1
        getBinContent2 = xform2 c_th1c_getbincontent2
        getBinContent3 = xform3 c_th1c_getbincontent3
        getBinError1 = xform1 c_th1c_getbinerror1
        getBinError2 = xform2 c_th1c_getbinerror2
        getBinError3 = xform3 c_th1c_getbinerror3
        getBinLowEdge = xform1 c_th1c_getbinlowedge
        getBinWidth = xform1 c_th1c_getbinwidth
        getCellContent = xform2 c_th1c_getcellcontent
        getCellError = xform2 c_th1c_getcellerror
        getEntries = xform0 c_th1c_getentries
        getEffectiveEntries = xform0 c_th1c_geteffectiveentries
        getFunction = xform1 c_th1c_getfunction
        getDimension = xform0 c_th1c_getdimension
        getKurtosis = xform1 c_th1c_getkurtosis
        getLowEdge = xform1 c_th1c_getlowedge
        getMaximumTH1 = xform1 c_th1c_getmaximumth1
        getMaximumBin = xform0 c_th1c_getmaximumbin
        getMaximumStored = xform0 c_th1c_getmaximumstored
        getMinimumTH1 = xform1 c_th1c_getminimumth1
        getMinimumBin = xform0 c_th1c_getminimumbin
        getMinimumStored = xform0 c_th1c_getminimumstored
        getMean = xform1 c_th1c_getmean
        getMeanError = xform1 c_th1c_getmeanerror
        getNbinsX = xform0 c_th1c_getnbinsx
        getNbinsY = xform0 c_th1c_getnbinsy
        getNbinsZ = xform0 c_th1c_getnbinsz
        getQuantilesTH1 = xform3 c_th1c_getquantilesth1
        getRandom = xform0 c_th1c_getrandom
        getStats = xform1 c_th1c_getstats
        getSumOfWeights = xform0 c_th1c_getsumofweights
        getSumw2 = xform0 c_th1c_getsumw2
        getSumw2N = xform0 c_th1c_getsumw2n
        getRMS = xform1 c_th1c_getrms
        getRMSError = xform1 c_th1c_getrmserror
        getSkewness = xform1 c_th1c_getskewness
        integral1 = xform3 c_th1c_integral1
        interpolate1 = xform1 c_th1c_interpolate1
        interpolate2 = xform2 c_th1c_interpolate2
        interpolate3 = xform3 c_th1c_interpolate3
        kolmogorovTest = xform2 c_th1c_kolmogorovtest
        labelsDeflate = xform1 c_th1c_labelsdeflate
        labelsInflate = xform1 c_th1c_labelsinflate
        labelsOption = xform2 c_th1c_labelsoption
        multiflyF = xform2 c_th1c_multiflyf
        multiply = xform5 c_th1c_multiply
        putStats = xform1 c_th1c_putstats
        rebin = xform3 c_th1c_rebin
        rebinAxis = xform2 c_th1c_rebinaxis
        rebuild = xform1 c_th1c_rebuild
        recursiveRemove = xform1 c_th1c_recursiveremove
        reset = xform1 c_th1c_reset
        resetStats = xform0 c_th1c_resetstats
        scale = xform2 c_th1c_scale
        setAxisColorA = xform2 c_th1c_setaxiscolora
        setAxisRange = xform3 c_th1c_setaxisrange
        setBarOffset = xform1 c_th1c_setbaroffset
        setBarWidth = xform1 c_th1c_setbarwidth
        setBinContent1 = xform2 c_th1c_setbincontent1
        setBinContent2 = xform3 c_th1c_setbincontent2
        setBinContent3 = xform4 c_th1c_setbincontent3
        setBinError1 = xform2 c_th1c_setbinerror1
        setBinError2 = xform3 c_th1c_setbinerror2
        setBinError3 = xform4 c_th1c_setbinerror3
        setBins1 = xform2 c_th1c_setbins1
        setBins2 = xform4 c_th1c_setbins2
        setBins3 = xform6 c_th1c_setbins3
        setBinsLength = xform1 c_th1c_setbinslength
        setBuffer = xform2 c_th1c_setbuffer
        setCellContent = xform3 c_th1c_setcellcontent
        setContent = xform1 c_th1c_setcontent
        setContour = xform2 c_th1c_setcontour
        setContourLevel = xform2 c_th1c_setcontourlevel
        setDirectory = xform1 c_th1c_setdirectory
        setEntries = xform1 c_th1c_setentries
        setError = xform1 c_th1c_seterror
        setLabelColorA = xform2 c_th1c_setlabelcolora
        setLabelSizeA = xform2 c_th1c_setlabelsizea
        setLabelFontA = xform2 c_th1c_setlabelfonta
        setLabelOffsetA = xform2 c_th1c_setlabeloffseta
        setMaximum = xform1 c_th1c_setmaximum
        setMinimum = xform1 c_th1c_setminimum
        setNormFactor = xform1 c_th1c_setnormfactor
        setStats = xform1 c_th1c_setstats
        setOption = xform1 c_th1c_setoption
        setXTitle = xform1 c_th1c_setxtitle
        setYTitle = xform1 c_th1c_setytitle
        setZTitle = xform1 c_th1c_setztitle
        showBackground = xform2 c_th1c_showbackground
        showPeaks = xform3 c_th1c_showpeaks
        smooth = xform2 c_th1c_smooth
        sumw2 = xform0 c_th1c_sumw2

instance ITArrayC TH1C

instance ITNamed TH1C where
        setName = xform1 c_th1c_setname
        setNameTitle = xform2 c_th1c_setnametitle
        setTitle = xform1 c_th1c_settitle

instance ITAttLine TH1C where
        getLineColor = xform0 c_th1c_getlinecolor
        getLineStyle = xform0 c_th1c_getlinestyle
        getLineWidth = xform0 c_th1c_getlinewidth
        resetAttLine = xform1 c_th1c_resetattline
        setLineAttributes = xform0 c_th1c_setlineattributes
        setLineColor = xform1 c_th1c_setlinecolor
        setLineStyle = xform1 c_th1c_setlinestyle
        setLineWidth = xform1 c_th1c_setlinewidth

instance ITAttFill TH1C where
        setFillColor = xform1 c_th1c_setfillcolor
        setFillStyle = xform1 c_th1c_setfillstyle

instance ITAttMarker TH1C where
        getMarkerColor = xform0 c_th1c_getmarkercolor
        getMarkerStyle = xform0 c_th1c_getmarkerstyle
        getMarkerSize = xform0 c_th1c_getmarkersize
        resetAttMarker = xform1 c_th1c_resetattmarker
        setMarkerAttributes = xform0 c_th1c_setmarkerattributes
        setMarkerColor = xform1 c_th1c_setmarkercolor
        setMarkerStyle = xform1 c_th1c_setmarkerstyle
        setMarkerSize = xform1 c_th1c_setmarkersize

instance ITObject TH1C where
        draw = xform1 c_th1c_draw
        findObject = xform1 c_th1c_findobject
        getName = xform0 c_th1c_getname
        isA = xform0 c_th1c_isa
        paint = xform1 c_th1c_paint
        printObj = xform1 c_th1c_printobj
        saveAs = xform2 c_th1c_saveas
        write = xform3 c_th1c_write

instance IDeletable TH1C where
        delete = xform0 c_th1c_delete

instance ITArray TH1C
