{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1I.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH1I.RawType
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayI.Interface

class (ITH1 a, ITArrayI a) => ITH1I a

upcastTH1I :: forall a . (FPtr a, ITH1I a) => a -> TH1I
upcastTH1I h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH1I = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH1I :: forall a . (FPtr a, ITH1I a) => TH1I -> a
downcastTH1I h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
