{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2Poly.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH2Poly.RawType
import HROOT.Hist.TH2.Interface

class ITH2 a => ITH2Poly a

upcastTH2Poly :: forall a . (FPtr a, ITH2Poly a) => a -> TH2Poly
upcastTH2Poly h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH2Poly = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH2Poly :: forall a . (FPtr a, ITH2Poly a) => TH2Poly -> a
downcastTH2Poly h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
