{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3D.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH3D.RawType
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayD.Interface

class (ITH3 a, ITArrayD a) => ITH3D a

upcastTH3D :: forall a . (FPtr a, ITH3D a) => a -> TH3D
upcastTH3D h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH3D = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH3D :: forall a . (FPtr a, ITH3D a) => TH3D -> a
downcastTH3D h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
