{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3F.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH3F.RawType
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayF.Interface

class (ITH3 a, ITArrayF a) => ITH3F a

upcastTH3F :: forall a . (FPtr a, ITH3F a) => a -> TH3F
upcastTH3F h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH3F = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH3F :: forall a . (FPtr a, ITH3F a) => TH3F -> a
downcastTH3F h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
