{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3I.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH3I.RawType
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayI.Interface

class (ITH3 a, ITArrayI a) => ITH3I a

upcastTH3I :: forall a . (FPtr a, ITH3I a) => a -> TH3I
upcastTH3I h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH3I = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH3I :: forall a . (FPtr a, ITH3I a) => TH3I -> a
downcastTH3I h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
