{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.THStack.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.THStack.RawType
import HROOT.Hist.THStack.FFI
import HROOT.Hist.THStack.Interface
import HROOT.Hist.THStack.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITHStack THStack

instance ITNamed THStack where
        setName = xform1 c_thstack_setname
        setNameTitle = xform2 c_thstack_setnametitle
        setTitle = xform1 c_thstack_settitle

instance ITObject THStack where
        draw = xform1 c_thstack_draw
        findObject = xform1 c_thstack_findobject
        getName = xform0 c_thstack_getname
        isA = xform0 c_thstack_isa
        paint = xform1 c_thstack_paint
        printObj = xform1 c_thstack_printobj
        saveAs = xform2 c_thstack_saveas
        write = xform3 c_thstack_write

instance IDeletable THStack where
        delete = xform0 c_thstack_delete

newTHStack ::
             (Castable c1 CString, Castable c0 CString) =>
             c0 -> c1 -> IO THStack
newTHStack = xform1 c_thstack_newthstack
