#include <MacroPatternMatch.h>
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttAxis.h"
#include "TAxis.h"
#include "HROOTHistTAxis.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TAxis)
TATTAXIS_DEF_VIRT(TAxis)
TOBJECT_DEF_VIRT(TAxis)
DELETABLE_DEF_VIRT(TAxis)

TAXIS_DEF_VIRT(TAxis)

TAXIS_DEF_NONVIRT(TAxis)

