#include <MacroPatternMatch.h>
#include "HROOTCoreTObject.h"
#include "HROOTHistTH1.h"
#include "HROOTHistTAxis.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "TF1.h"
#include "HROOTHistTF1.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TATTLINE_DEF_VIRT(TF1)
TATTFILL_DEF_VIRT(TF1)
TATTMARKER_DEF_VIRT(TF1)
DELETABLE_DEF_VIRT(TF1)

TF1_DEF_VIRT(TF1)

TF1_DEF_NONVIRT(TF1)

