#include <MacroPatternMatch.h>
#include "HROOTCoreTNamed.h"
#include "TFitResult.h"
#include "HROOTHistTFitResult.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TFitResult)
TOBJECT_DEF_VIRT(TFitResult)
DELETABLE_DEF_VIRT(TFitResult)

TFITRESULT_DEF_VIRT(TFitResult)

TFITRESULT_DEF_NONVIRT(TFitResult)

