#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TGraphAsymmErrors__
#define __HROOT_HIST__TGraphAsymmErrors__

#include "HROOT-histType.h"
#include "HROOTHistTGraph.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TGRAPHASYMMERRORS_DECL_VIRT 
#define TGRAPHASYMMERRORS_DECL_VIRT(Type) \


#undef TGRAPHASYMMERRORS_DECL_NONVIRT 
#define TGRAPHASYMMERRORS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTGraphAsymmErrors ( int n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh )

#undef TGRAPHASYMMERRORS_DEF_VIRT
#define TGRAPHASYMMERRORS_DEF_VIRT(Type)\


#undef TGRAPHASYMMERRORS_DEF_NONVIRT
#define TGRAPHASYMMERRORS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTGraphAsymmErrors ( int n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh )\
{\
Type * newp = new Type (n, x, y, exl, exh, eyl, eyh); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TGRAPH_DECL_VIRT(TGraphAsymmErrors);
TNAMED_DECL_VIRT(TGraphAsymmErrors);
TATTLINE_DECL_VIRT(TGraphAsymmErrors);
TATTFILL_DECL_VIRT(TGraphAsymmErrors);
TATTMARKER_DECL_VIRT(TGraphAsymmErrors);
TOBJECT_DECL_VIRT(TGraphAsymmErrors);
DELETABLE_DECL_VIRT(TGraphAsymmErrors);


TGRAPHASYMMERRORS_DECL_VIRT(TGraphAsymmErrors);


TGRAPHASYMMERRORS_DECL_NONVIRT(TGraphAsymmErrors);


#endif // __HROOT_HIST__TGraphAsymmErrors__

#ifdef __cplusplus
}
#endif

