#include <MacroPatternMatch.h>
#include "HROOTHistTGraph.h"
#include "TGraphBentErrors.h"
#include "HROOTHistTGraphBentErrors.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TGRAPH_DEF_VIRT(TGraphBentErrors)
TNAMED_DEF_VIRT(TGraphBentErrors)
TATTLINE_DEF_VIRT(TGraphBentErrors)
TATTFILL_DEF_VIRT(TGraphBentErrors)
TATTMARKER_DEF_VIRT(TGraphBentErrors)
TOBJECT_DEF_VIRT(TGraphBentErrors)
DELETABLE_DEF_VIRT(TGraphBentErrors)

TGRAPHBENTERRORS_DEF_VIRT(TGraphBentErrors)

TGRAPHBENTERRORS_DEF_NONVIRT(TGraphBentErrors)

