#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TGraphBentErrors__
#define __HROOT_HIST__TGraphBentErrors__

#include "HROOT-histType.h"
#include "HROOTHistTGraph.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TGRAPHBENTERRORS_DECL_VIRT 
#define TGRAPHBENTERRORS_DECL_VIRT(Type) \


#undef TGRAPHBENTERRORS_DECL_NONVIRT 
#define TGRAPHBENTERRORS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTGraphBentErrors ( int n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh, double * exld, double * exhd, double * eyld, double * eyhd )

#undef TGRAPHBENTERRORS_DEF_VIRT
#define TGRAPHBENTERRORS_DEF_VIRT(Type)\


#undef TGRAPHBENTERRORS_DEF_NONVIRT
#define TGRAPHBENTERRORS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTGraphBentErrors ( int n, double * x, double * y, double * exl, double * exh, double * eyl, double * eyh, double * exld, double * exhd, double * eyld, double * eyhd )\
{\
Type * newp = new Type (n, x, y, exl, exh, eyl, eyh, exld, exhd, eyld, eyhd); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TGRAPH_DECL_VIRT(TGraphBentErrors);
TNAMED_DECL_VIRT(TGraphBentErrors);
TATTLINE_DECL_VIRT(TGraphBentErrors);
TATTFILL_DECL_VIRT(TGraphBentErrors);
TATTMARKER_DECL_VIRT(TGraphBentErrors);
TOBJECT_DECL_VIRT(TGraphBentErrors);
DELETABLE_DECL_VIRT(TGraphBentErrors);


TGRAPHBENTERRORS_DECL_VIRT(TGraphBentErrors);


TGRAPHBENTERRORS_DECL_NONVIRT(TGraphBentErrors);


#endif // __HROOT_HIST__TGraphBentErrors__

#ifdef __cplusplus
}
#endif

