#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TGraphErrors__
#define __HROOT_HIST__TGraphErrors__

#include "HROOT-histType.h"
#include "HROOTHistTGraph.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TGRAPHERRORS_DECL_VIRT 
#define TGRAPHERRORS_DECL_VIRT(Type) \


#undef TGRAPHERRORS_DECL_NONVIRT 
#define TGRAPHERRORS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTGraphErrors ( int n, double * x, double * y, double * ex, double * ey )

#undef TGRAPHERRORS_DEF_VIRT
#define TGRAPHERRORS_DEF_VIRT(Type)\


#undef TGRAPHERRORS_DEF_NONVIRT
#define TGRAPHERRORS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTGraphErrors ( int n, double * x, double * y, double * ex, double * ey )\
{\
Type * newp = new Type (n, x, y, ex, ey); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TGRAPH_DECL_VIRT(TGraphErrors);
TNAMED_DECL_VIRT(TGraphErrors);
TATTLINE_DECL_VIRT(TGraphErrors);
TATTFILL_DECL_VIRT(TGraphErrors);
TATTMARKER_DECL_VIRT(TGraphErrors);
TOBJECT_DECL_VIRT(TGraphErrors);
DELETABLE_DECL_VIRT(TGraphErrors);


TGRAPHERRORS_DECL_VIRT(TGraphErrors);


TGRAPHERRORS_DECL_NONVIRT(TGraphErrors);


#endif // __HROOT_HIST__TGraphErrors__

#ifdef __cplusplus
}
#endif

