#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH1F__
#define __HROOT_HIST__TH1F__

#include "HROOT-histType.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTArrayF.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH1F_DECL_VIRT 
#define TH1F_DECL_VIRT(Type) \


#undef TH1F_DECL_NONVIRT 
#define TH1F_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTH1F ( const char* name, const char* title, int nbinsx, double xlow, double xup )

#undef TH1F_DEF_VIRT
#define TH1F_DEF_VIRT(Type)\


#undef TH1F_DEF_NONVIRT
#define TH1F_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTH1F ( const char* name, const char* title, int nbinsx, double xlow, double xup )\
{\
Type * newp = new Type (name, title, nbinsx, xlow, xup); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TH1_DECL_VIRT(TH1F);
TARRAYF_DECL_VIRT(TH1F);
TNAMED_DECL_VIRT(TH1F);
TATTLINE_DECL_VIRT(TH1F);
TATTFILL_DECL_VIRT(TH1F);
TATTMARKER_DECL_VIRT(TH1F);
TOBJECT_DECL_VIRT(TH1F);
DELETABLE_DECL_VIRT(TH1F);
TARRAY_DECL_VIRT(TH1F);


TH1F_DECL_VIRT(TH1F);


TH1F_DECL_NONVIRT(TH1F);


#endif // __HROOT_HIST__TH1F__

#ifdef __cplusplus
}
#endif

