#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH1K__
#define __HROOT_HIST__TH1K__

#include "HROOT-histType.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTArrayF.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH1K_DECL_VIRT 
#define TH1K_DECL_VIRT(Type) \


#undef TH1K_DECL_NONVIRT 
#define TH1K_DECL_NONVIRT(Type) \


#undef TH1K_DEF_VIRT
#define TH1K_DEF_VIRT(Type)\


#undef TH1K_DEF_NONVIRT
#define TH1K_DEF_NONVIRT(Type)\


TH1_DECL_VIRT(TH1K);
TARRAYF_DECL_VIRT(TH1K);
TNAMED_DECL_VIRT(TH1K);
TATTLINE_DECL_VIRT(TH1K);
TATTFILL_DECL_VIRT(TH1K);
TATTMARKER_DECL_VIRT(TH1K);
TOBJECT_DECL_VIRT(TH1K);
DELETABLE_DECL_VIRT(TH1K);
TARRAY_DECL_VIRT(TH1K);


TH1K_DECL_VIRT(TH1K);


TH1K_DECL_NONVIRT(TH1K);


#endif // __HROOT_HIST__TH1K__

#ifdef __cplusplus
}
#endif

