#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH2S__
#define __HROOT_HIST__TH2S__

#include "HROOT-histType.h"
#include "HROOTHistTH2.h"
#include "HROOTCoreTArrayS.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH2S_DECL_VIRT 
#define TH2S_DECL_VIRT(Type) \


#undef TH2S_DECL_NONVIRT 
#define TH2S_DECL_NONVIRT(Type) \


#undef TH2S_DEF_VIRT
#define TH2S_DEF_VIRT(Type)\


#undef TH2S_DEF_NONVIRT
#define TH2S_DEF_NONVIRT(Type)\


TH2_DECL_VIRT(TH2S);
TARRAYS_DECL_VIRT(TH2S);
TH1_DECL_VIRT(TH2S);
TNAMED_DECL_VIRT(TH2S);
TATTLINE_DECL_VIRT(TH2S);
TATTFILL_DECL_VIRT(TH2S);
TATTMARKER_DECL_VIRT(TH2S);
TOBJECT_DECL_VIRT(TH2S);
DELETABLE_DECL_VIRT(TH2S);
TARRAY_DECL_VIRT(TH2S);


TH2S_DECL_VIRT(TH2S);


TH2S_DECL_NONVIRT(TH2S);


#endif // __HROOT_HIST__TH2S__

#ifdef __cplusplus
}
#endif

