#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH3C__
#define __HROOT_HIST__TH3C__

#include "HROOT-histType.h"
#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayC.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH3C_DECL_VIRT 
#define TH3C_DECL_VIRT(Type) \


#undef TH3C_DECL_NONVIRT 
#define TH3C_DECL_NONVIRT(Type) \


#undef TH3C_DEF_VIRT
#define TH3C_DEF_VIRT(Type)\


#undef TH3C_DEF_NONVIRT
#define TH3C_DEF_NONVIRT(Type)\


TH3_DECL_VIRT(TH3C);
TARRAYC_DECL_VIRT(TH3C);
TH1_DECL_VIRT(TH3C);
TATT3D_DECL_VIRT(TH3C);
TNAMED_DECL_VIRT(TH3C);
TATTLINE_DECL_VIRT(TH3C);
TATTFILL_DECL_VIRT(TH3C);
TATTMARKER_DECL_VIRT(TH3C);
TOBJECT_DECL_VIRT(TH3C);
DELETABLE_DECL_VIRT(TH3C);
TARRAY_DECL_VIRT(TH3C);


TH3C_DECL_VIRT(TH3C);


TH3C_DECL_NONVIRT(TH3C);


#endif // __HROOT_HIST__TH3C__

#ifdef __cplusplus
}
#endif

