#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH3F__
#define __HROOT_HIST__TH3F__

#include "HROOT-histType.h"
#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayF.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH3F_DECL_VIRT 
#define TH3F_DECL_VIRT(Type) \


#undef TH3F_DECL_NONVIRT 
#define TH3F_DECL_NONVIRT(Type) \


#undef TH3F_DEF_VIRT
#define TH3F_DEF_VIRT(Type)\


#undef TH3F_DEF_NONVIRT
#define TH3F_DEF_NONVIRT(Type)\


TH3_DECL_VIRT(TH3F);
TARRAYF_DECL_VIRT(TH3F);
TH1_DECL_VIRT(TH3F);
TATT3D_DECL_VIRT(TH3F);
TNAMED_DECL_VIRT(TH3F);
TATTLINE_DECL_VIRT(TH3F);
TATTFILL_DECL_VIRT(TH3F);
TATTMARKER_DECL_VIRT(TH3F);
TOBJECT_DECL_VIRT(TH3F);
DELETABLE_DECL_VIRT(TH3F);
TARRAY_DECL_VIRT(TH3F);


TH3F_DECL_VIRT(TH3F);


TH3F_DECL_NONVIRT(TH3F);


#endif // __HROOT_HIST__TH3F__

#ifdef __cplusplus
}
#endif

