#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_HIST__TH3S__
#define __HROOT_HIST__TH3S__

#include "HROOT-histType.h"
#include "HROOTHistTH3.h"
#include "HROOTCoreTArrayS.h"
#include "HROOTHistTH1.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOTCoreTArray.h"
#include "HROOT-coreType.h"

#undef TH3S_DECL_VIRT 
#define TH3S_DECL_VIRT(Type) \


#undef TH3S_DECL_NONVIRT 
#define TH3S_DECL_NONVIRT(Type) \


#undef TH3S_DEF_VIRT
#define TH3S_DEF_VIRT(Type)\


#undef TH3S_DEF_NONVIRT
#define TH3S_DEF_NONVIRT(Type)\


TH3_DECL_VIRT(TH3S);
TARRAYS_DECL_VIRT(TH3S);
TH1_DECL_VIRT(TH3S);
TATT3D_DECL_VIRT(TH3S);
TNAMED_DECL_VIRT(TH3S);
TATTLINE_DECL_VIRT(TH3S);
TATTFILL_DECL_VIRT(TH3S);
TATTMARKER_DECL_VIRT(TH3S);
TOBJECT_DECL_VIRT(TH3S);
DELETABLE_DECL_VIRT(TH3S);
TARRAY_DECL_VIRT(TH3S);


TH3S_DECL_VIRT(TH3S);


TH3S_DECL_NONVIRT(TH3S);


#endif // __HROOT_HIST__TH3S__

#ifdef __cplusplus
}
#endif

