{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TFitResult.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Hist.TFitResult.RawType
import HROOT.Hist.TFitResult.FFI
import HROOT.Hist.TFitResult.Interface
import HROOT.Hist.TFitResult.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITFitResult TFitResult

instance ITNamed TFitResult where
        setName = xform1 c_tfitresult_setname
        setNameTitle = xform2 c_tfitresult_setnametitle
        setTitle = xform1 c_tfitresult_settitle

instance ITObject TFitResult where
        draw = xform1 c_tfitresult_draw
        findObject = xform1 c_tfitresult_findobject
        getName = xform0 c_tfitresult_getname
        isA = xform0 c_tfitresult_isa
        paint = xform1 c_tfitresult_paint
        printObj = xform1 c_tfitresult_printobj
        saveAs = xform2 c_tfitresult_saveas
        write = xform3 c_tfitresult_write

instance IDeletable TFitResult where
        delete = xform0 c_tfitresult_delete
