{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TGraphErrors.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TGraphErrors.RawType
import HROOT.Hist.TGraph.Interface

class ITGraph a => ITGraphErrors a

upcastTGraphErrors ::
                   forall a . (FPtr a, ITGraphErrors a) => a -> TGraphErrors
upcastTGraphErrors h
  = let fh = get_fptr h
        fh2 :: Ptr RawTGraphErrors = castPtr fh
      in cast_fptr_to_obj fh2

downcastTGraphErrors ::
                     forall a . (FPtr a, ITGraphErrors a) => TGraphErrors -> a
downcastTGraphErrors h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
