{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1C.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH1C.RawType
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayC.Interface

class (ITH1 a, ITArrayC a) => ITH1C a

upcastTH1C :: forall a . (FPtr a, ITH1C a) => a -> TH1C
upcastTH1C h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH1C = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH1C :: forall a . (FPtr a, ITH1C a) => TH1C -> a
downcastTH1C h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
