{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1D.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH1D.RawType
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayD.Interface

class (ITH1 a, ITArrayD a) => ITH1D a

upcastTH1D :: forall a . (FPtr a, ITH1D a) => a -> TH1D
upcastTH1D h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH1D = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH1D :: forall a . (FPtr a, ITH1D a) => TH1D -> a
downcastTH1D h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
