{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH1F.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayF.Interface

class (ITH1 a, ITArrayF a) => ITH1F a

upcastTH1F :: forall a . (FPtr a, ITH1F a) => a -> TH1F
upcastTH1F h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH1F = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH1F :: forall a . (FPtr a, ITH1F a) => TH1F -> a
downcastTH1F h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
