{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH2D.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH2D.RawType
import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayD.Interface

class (ITH2 a, ITArrayD a) => ITH2D a

upcastTH2D :: forall a . (FPtr a, ITH2D a) => a -> TH2D
upcastTH2D h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH2D = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH2D :: forall a . (FPtr a, ITH2D a) => TH2D -> a
downcastTH2D h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
