{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TH3S.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TH3S.RawType
import HROOT.Hist.TH3.Interface
import HROOT.Core.TArrayS.Interface

class (ITH3 a, ITArrayS a) => ITH3S a

upcastTH3S :: forall a . (FPtr a, ITH3S a) => a -> TH3S
upcastTH3S h
  = let fh = get_fptr h
        fh2 :: Ptr RawTH3S = castPtr fh
      in cast_fptr_to_obj fh2

downcastTH3S :: forall a . (FPtr a, ITH3S a) => TH3S -> a
downcastTH3S h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
