{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Hist.THStack.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Hist.THStack.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTHistTHStack.h THStack_SetName"
               c_thstack_setname :: Ptr RawTHStack -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_SetNameTitle"
               c_thstack_setnametitle ::
               Ptr RawTHStack -> CString -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_SetTitle"
               c_thstack_settitle :: Ptr RawTHStack -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_Draw"
               c_thstack_draw :: Ptr RawTHStack -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_FindObject"
               c_thstack_findobject ::
               Ptr RawTHStack -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTHistTHStack.h THStack_GetName"
               c_thstack_getname :: Ptr RawTHStack -> IO CString

foreign import ccall safe "HROOTHistTHStack.h THStack_IsA"
               c_thstack_isa :: Ptr RawTHStack -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTHistTHStack.h THStack_Paint"
               c_thstack_paint :: Ptr RawTHStack -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_printObj"
               c_thstack_printobj :: Ptr RawTHStack -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_SaveAs"
               c_thstack_saveas :: Ptr RawTHStack -> CString -> CString -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_Write"
               c_thstack_write ::
               Ptr RawTHStack -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe "HROOTHistTHStack.h THStack_delete"
               c_thstack_delete :: Ptr RawTHStack -> IO ()

foreign import ccall safe "HROOTHistTHStack.h THStack_newTHStack"
               c_thstack_newthstack :: CString -> CString -> IO (Ptr RawTHStack)
